/*
 *  TOPPERS/FMP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Flexible MultiProcessor Kernel
 *
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2006-2012 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 *  @(#) $Id: chip_config_tool.h 1018 2013-07-11 11:40:02Z ertl-honda $
 */

/*
 *  åװ¸⥸塼Υġ¸MPCOREѡ
 *
 *  ͥΥåװ¸Υ󥯥롼ɥեΥġ¸
 *  chip_config.h 饤󥯥롼ɤ롥
 */

#ifndef TOPPERS_CHIP_CONFIG_TOOL_H
#define TOPPERS_CHIP_CONFIG_TOOL_H

#ifndef TOPPERS_MACRO_ONLY
/*
 *  åؿ
 *  x_lock_cpu()/x_unlock_cpu()Ȥᡤ¸⥸塼ARMѡˤ
 *  ɤ߹Ǥ롥
 */

/*
 *  åԻγԤ
 *
 *  MPCoreǤϡåԻ˥ԥ򷫤֤ΤǤϤʤwfeˤꡤ
 *  ٥ԤȤ뤳Ȥ侩Ƥ롥
 *  wfeˤ륤٥Ԥκݡ߱㲼ʤᡤߤ
 *  Ĥ֤ơ٥ԤȤ٤Ǥ롥wfe̿Ἣϡߤ
 *  ߡĤʤᡤmsr̿ˤߤĤ롥
 *
 *  κݡmsr¹ԤˤߤĤ줿ľ(wfe¹Ԥ)˳
 *  ߤꡤθߥϥɥ餫Υ꥿wfeˤʤꡤ٥Ȥ
 *  ƨǽͤ롥
 *
 *  ʤ顤 ߥϥɥ餫Υ꥿(Τˤ㳰̤Υ꥿
 *  )Ԥȡ٥ȥ쥸åȤ졤wfe¹Ի˥٥ȥ쥸
 *  åȤƤȡꥢwfe¨¤˥꥿󤹤뤿
 *  ʤ
 */

/*
 *  1ܤΥåʥ󥿥ƥȶѡ
 */
Inline void
x_acquire_lock(LOCK *p_lock)
{
	int		locked;

	while(true) {
		Asm("   mov      r2, #0x01   \n"
			"\t ldrex    r1, [%1]    \n"
			"\t cmp      r1, #0x00   \n"
			"\t msrne    cpsr_c, %2  \n" /* ߤε(bit0-7Τ߽񤭴) */
			"\t wfene                \n"
			"\t msrne    cpsr_c, %3  \n" /* ߤζػ(bit0-7Τ߽񤭴) */
			"\t strexeq  r1, r2,[%1] \n"
			"\t mov      %0, r1      \n"
			:"=r"(locked)
			:"r"(p_lock),"I"(CPSR_SVC|CPSR_ALWAYS_SET),"I"(CPSR_SVC|CPSR_CPULOCK|CPSR_ALWAYS_SET)
			:"r1","r2", "cc");

		if(locked == 0){
			/* å */
			mpcore_data_memory_barrier();
			Asm("":::"memory");
			return;
		}
	}
}

#define t_acquire_lock(p_lock) x_acquire_lock(p_lock)
#define i_acquire_lock(p_lock) x_acquire_lock(p_lock)

#if TTYPE_KLOCK != G_KLOCK

/*
 *  2ܰʾΥåʥ󥿥ƥȶѡ
 */
Inline bool_t
x_acquire_nested_lock(LOCK *p_lock)
{
	PCB		*p_pcb;
	int		locked;

	while(true) {
		Asm("   mov      r2, #0x01   \n"
			"\t ldrex    r1, [%1]    \n"
			"\t cmp      r1, #0x00   \n"
			"\t msrne    cpsr_c, %2  \n" /* ߤε(bit0-7Τ߽񤭴) */
			"\t wfene                \n"
			"\t msrne    cpsr_c, %3  \n" /* ߤζػ(bit0-7Τ߽񤭴) */
			"\t strexeq  r1, r2,[%1] \n"
			"\t mov      %0, r1      \n"
			:"=r"(locked)
			:"r"(p_lock),"I"(CPSR_SVC|CPSR_ALWAYS_SET),"I"(CPSR_SVC|CPSR_CPULOCK|CPSR_ALWAYS_SET)
			:"r1","r2", "cc");
		if(locked == 0){
			/* å */
			mpcore_data_memory_barrier();
			Asm("":::"memory");
			return(false);
		}
		/*
		 * ޥ졼󤹤ǽΤǤ
		 * 󥿥ƥȤξ硤ޥ졼󤷤ʤᡤ
		 * while˼¹ԤƤ褤1ǥåȤ줿硤
		 * ΨΤǡǼ롥
		 */
		p_pcb = get_my_p_pcb();
		if (p_pcb->p_firstlock == NULL) {
			return(true);
		}
	}
}

#define t_acquire_nested_lock(p_lock) x_acquire_nested_lock(p_lock)
#define i_acquire_nested_lock(p_lock) x_acquire_nested_lock(p_lock)

#endif /* TTYPE_KLOCK != G_KLOCK */

/*
 *  åβʥ󥿥ƥȶѡ
 */
Inline void
x_release_lock(LOCK *p_lock)
{
	Asm("":::"memory");
	mpcore_data_memory_barrier();
	*p_lock = 0;
	mpcore_data_sync_barrier();
	Asm("sev");
}

/*
 *  Ĥʤåؿ
 */
Inline void
x_acquire_lock_without_preemption(LOCK *p_lock)
{
	int		locked;

	while(true) {
		Asm("   mov      r2, #0x01   \n"
			"\t ldrex    r1, [%1]    \n"
			"\t cmp      r1, #0x00   \n"
			"\t wfene                \n"
			"\t strexeq  r1, r2,[%1] \n"
			"\t mov      %0, r1      \n"
			:"=r"(locked):"r"(p_lock):"r1","r2", "cc");
		if(locked == 0){
			/* å */
			mpcore_data_memory_barrier();
			Asm("":::"memory");
			return;
		}
	}
}

/*
 *  ԥåǽΥͥƥ֥åǻѤؿ
 */

/*
 *  ԥåη
 */
typedef uint32_t SPNLOCK;

/*
 *  ԥåν
 */
Inline void
x_initialize_spin(ID spnid, SPNLOCK *p_spn_lock)
{
	*p_spn_lock = 0;
}

/*
 *  ԥåμ
 */
Inline void
x_lock_spin(SPNLOCK *p_spn_lock)
{
	x_acquire_lock(p_spn_lock);
}

#define t_lock_spin(p_spn_lock)  x_lock_spin(p_spn_lock)
#define i_lock_spin(p_spn_lock)  x_lock_spin(p_spn_lock)

/*
 *  ԥåμλ
 */
Inline bool_t
x_try_lock_spin(SPNLOCK *p_spn_lock)
{
	int locked;

	Asm("   mov      r2, #0x01   \n"
		"\t ldrex    r1, [%1]    \n"
		"\t cmp      r1, #0x00   \n"
		"\t strexeq  r1, r2,[%1] \n"
		"\t mov      %0, r1      \n"
		:"=r"(locked):"r"(p_spn_lock):"r1","r2", "cc");

	if (locked == 0) {
		/*  */
		mpcore_data_memory_barrier();
		Asm("":::"memory");
		return(false);
	}

	return(true);
}

/*
 *  ԥåֵ
 */
Inline void
x_unlock_spin(SPNLOCK *p_spn_lock)
{
	x_release_lock(p_spn_lock);
}
#endif /* TOPPERS_MACRO_ONLY */

#endif /* TOPPERS_CHIP_CONFIG_TOOL_H */
